let jsonASC = function(property) {
	return function(a, b) {
		var value1 = a[property];
		var value2 = b[property];
		return value1-value2;
	}
}
let product_item_ids = [];
let data = [];//定义匹配数据
//接口返回的数据
api_data.resp_value.forEach(function(d,i){
	d.config = {};
	d.supplier_info.config_info.forEach(function(e,i){
		d.config[e.key] = e.value;
	})
	data.push({
		supplier_id:d.supplier_id,
		supplier_info:{
			supplier_id:d.supplier_info.supplier_id,
			supplier_name:d.supplier_info.supplier_name,
			delivery_min_price:d.config.SUPPLIER_MIN_ORDER_DELIVERY_MONEY_AMOUNT,
			delivery_min_price_shortfall:d.config.SUPPLIER_MIN_ORDER_DELIVERY_MONEY_AMOUNT,
			total_product_count: d.supplier_info.total_product_count,
			config_info:d.supplier_info.config_info,
			product_category_tree:d.supplier_info.product_category_tree,
			config:d.config
		},
		items:[]
	})
	d.items.forEach(function(e,j){
		product_item_ids.push(e.item_id);
		data[i].items.push({
			attachment_id:e.attachment_id,
			item_id: e.item_id,
			shelf_id: e.shelf_id,
			product_name: e.product_name,
			price:e.price,
			order_qty:e.order_qty,
			shelf_stock:e.shelf_stock?e.shelf_stock:0,
			is_min_price:false,
			is_best_match:false,
			is_adjust:false
		});
	})
})
let min_price_product_items = {};
let max_product_items = {};
product_item_ids.forEach(function(d,i){
	min_price_product_items[d] = [];
	max_product_items[d] = [];
})
//寻找低价商品
data.forEach(function(d,i){
	d.items.forEach(function(e,j){
		min_price_product_items[e.item_id].push({
			index:i,
			price:e.price
		});
	})
});
//按商品价格正序排序
Object.keys(min_price_product_items).forEach(function(i){
	min_price_product_items[i] = min_price_product_items[i].sort(jsonASC("price"));
})
//标记低价商品和最优推荐是否可调整商品
data.forEach(function(d,i){
	d.items.forEach(function(e,j){
		Object.keys(min_price_product_items).forEach(function(k){
			if(k==e.item_id){
				if(min_price_product_items[k][0].index==i){
					e.is_min_price = true;
					e.is_best_match = true;
				}
				if(min_price_product_items[k].length>1){
					e.is_adjust = true;
				}
			}
		})
	})
});
//计算起送差额、合计、供货商预计下单商品数量
data.forEach(function(d,i){
	d.order_amount = 0;
	d.order_count = 0;
	d.items.forEach(function(e,j){
		if(e.is_best_match){
			d.order_amount += e.price * (e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock);
			d.order_count += e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock;
		}
	})
	d.supplier_info.delivery_min_price_shortfall = d.supplier_info.delivery_min_price - d.order_amount;
});
//商品移动标记
data.forEach(function(d,i){
	d.items.forEach(function(e,j){
		max_product_items[e.item_id].push({
			index:i,
			index_old:-1,
			move:false
		});
	})
});
//标记需要移动的商品
data.forEach(function(d,i){
	d.items.forEach(function(e,j){
		Object.keys(min_price_product_items).forEach(function(k){
			if(k==e.item_id){
				if(min_price_product_items[k][0].index==i){
					if(d.supplier_info.delivery_min_price_shortfall>0&&i>0&&min_price_product_items[k].length>1){
						e.is_best_match = false;
						Object.keys(max_product_items).forEach(function(l){
							if(l==e.item_id){
								try {
									max_product_items[l].forEach(function(h,m){
										if(h.index != i){
											h.move = true;
											h.index_old = min_price_product_items[k][0].index;
											throw new Error("LoopTerminates");
										}
									})
								}catch (e) {
									if (e.message !== "LoopTerminates") throw e;
								}
							}
						})
					}
				}
			}
		})
	})
});
//重新标记最优推荐商品
data.forEach(function(d,i){
	d.is_best_match_null = true;
	d.items.forEach(function(e,j){
		Object.keys(max_product_items).forEach(function(k){
			max_product_items[k].forEach(function(g,l){
				if(k==e.item_id&&g.index==i&&g.move){
					e.is_best_match = true;
				}
			})
		})
		if(e.is_best_match){
			d.is_best_match_null = false;
		}
	})
});
//重新计算起送差额、合计、供货商预计下单商品数量
data.forEach(function(d,i){
	d.order_amount = 0;
	d.order_count = 0;
	d.items.forEach(function(e,j){
		if(e.is_best_match){
			d.order_amount += e.price * (e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock);
			d.order_count += e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock;
		}
		if(d.is_best_match_null){
			d.order_amount += e.price * (e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock);
			d.order_count += e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock;
		}
	})
	d.supplier_info.delivery_min_price_shortfall = d.supplier_info.delivery_min_price - d.order_amount;
});
//移动商品后还是不满起送金额，商品回退之前状态
Object.keys(max_product_items).forEach(function(k){
	max_product_items[k].forEach(function(g,l){
		if(g.move){
			//起送差额大于0时回退商品之前位置
			if(data[g.index].supplier_info.delivery_min_price_shortfall>0){
				data[g.index].items.forEach(function(e,j){
					if(e.item_id == k){
						e.is_best_match = false;
					}
				})
				data[g.index_old].items.forEach(function(e,j){
					if(e.item_id == k){
						e.is_best_match = true;
					}
				})
			}
		}
	})
})
//标记供货商下的所有商品都不是最优推荐
data.forEach(function(d,i){
	d.is_best_match_null = true;
	d.items.forEach(function(e,j){
		if(e.is_best_match){
			d.is_best_match_null = false;
		}
	})
});
//重新计算起送差额、合计、供货商预计下单商品数量
data.forEach(function(d,i){
	d.order_amount = 0;
	d.order_count = 0;
	d.items.forEach(function(e,j){
		if(e.is_best_match){
			d.order_amount += e.price * (e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock);
			d.order_count += e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock;
		}
		if(d.is_best_match_null){
			d.order_amount += e.price * (e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock);
			d.order_count += e.shelf_stock>=e.order_qty?e.order_qty:e.shelf_stock;
		}
	})
	d.supplier_info.delivery_min_price_shortfall = d.supplier_info.delivery_min_price - d.order_amount;
});
console.log(data);